Description

- Open field calculator

- Expression 10/ toreal( 3)

- Set to create a new field type (integer), width 10.

Result? 3.33333333333333

This is obviously wrong. When I save the shapefile it will be truncated to "3", which is right. But QGIS should never return

3.333333333333 in the first place, because it is invalid for the data type of the output format. The fact the result changes when saved is

anathema to all conventions of data handling.

History

#1 - 2013-10-17 07:49 AM - Nathan Woodrow

This is more of a issue with the attribute table and attribute dialog itself.  The expression engine is just doing what it is asked and returning the result. It

seems the field is storing the full value even though it's an int although I don't know how.

#2 - 2013-10-17 08:03 AM - Alexander Bruy

This is obviously correct. You divide integer to real and result surprisingly will be... real. Use toint() function in such cases or don't cast integer to float

before division.

Also when you try save float value into integer-type field, this float will be converted (if possible) to int. So all, I stress, all works correct.

#3 - 2013-10-17 08:12 AM - Jonathan Moules

Sorry Alexander, I disagree strongly.

Yes, mathematically the result (3.33333.) is obviously correct. However, because the output field is an integer, it cannot store anything beyond the "3". So

QGIS should never say 3.33333333 in the attribute result if the output field can't handle that.

QGIS is doing the conversion of 3.33333 to 3 (float to int) at save time. I'm saying it should do it before it puts it into the attribute table in the first place.

Similarly, if the output field is set to only allow two decimal places, qgis should only show two decimal places when the result is returned.

To do otherwise will confuse the vast majority of users when their data "changes".

#4 - 2013-10-24 12:38 AM - Matthias Kuhn
It's true, the expression engine produces a QVariant which can be of a variety of types.

And it seems these values are stored like they are returned to the local edit buffer until being committed. This affects much more than the representation in

the attribute table.

E.g.

Imagine a layer with an INT field a, calculated to 3.6

If you now create a new INT field b by multiplying a with 3 and you perform this calculation on uncommitted values the result will be 10.8 (later truncated to

10). If this calculation is done on committed values, the result will be 9.

It should be the edit buffer or vector layer taking care of field conversion on UPDATE / INSERT operations, so also values which originate from python

scripts or other sources will be converted.

#5 - 2014-06-21 01:12 PM - Jürgen Fischer

- Category set to Vectors

#6 - 2017-05-01 01:09 AM - Giovanni Manghi

- Regression? set to No

- Easy fix? set to No

#7 - 2018-03-01 12:28 PM - Giovanni Manghi

- Status changed from Open to Feedback

Please test with a recent QGIS release (2.18 or 3), if the issue/request is still valid change the affected version accordingly, if is fixed/implemented then

close the ticket. Thanks!

#8 - 2018-05-16 05:49 PM - Alexander Bruy

- Resolution set to fixed/implemented

- Description updated

- Status changed from Feedback to Closed
